Bug 500206 - valgrind complains
valgrind complains
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: python (Show other bugs)
14
All Linux
low Severity low
: ---
: ---
Assigned To: James Antill
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks: 658949
  Show dependency treegraph
 
Reported: 2009-05-11 13:04 EDT by Jan Kratochvil
Modified: 2012-08-16 17:55 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-08-16 17:55:37 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Fix for x86_64. (1.45 KB, patch)
2009-05-11 16:20 EDT, Jan Kratochvil
no flags Details | Diff

  None (edit)
Description Jan Kratochvil 2009-05-11 13:04:24 EDT
Description of problem:
Python library has various memory issues such as reading already freed memory.
This makes it hard/impossible to use valgrind on applications linking with libpython (such as Fedora gdb).
I did not investigate if the python code can cause real problems; expecting it does not.

Version-Release number of selected component (if applicable):
python-libs-2.6-7.fc11.x86_64

How reproducible:
Always

Steps to Reproduce:
valgrind python
  
Actual results:==31196== Memcheck, a memory error detector.
==31196== Copyright (C) 2002-2008, and GNU GPL'd, by Julian Seward et al.
==31196== Using LibVEX rev 1884, a library for dynamic binary translation.
==31196== Copyright (C) 2004-2008, and GNU GPL'd, by OpenWorks LLP.
==31196== Using valgrind-3.4.1, a dynamic binary instrumentation framework.
==31196== Copyright (C) 2000-2008, and GNU GPL'd, by Julian Seward et al.
==31196== For more details, rerun with: -v
==31196== 
==31196== Invalid read of size 4
==31196==    at 0x37C0E85423: PyObject_Free (in /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0E59AAA: (within /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0EF1A27: (within /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0EF2F74: (within /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0EF3203: (within /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0EF3871: (within /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0EF3E03: PyImport_ImportModuleLevel (in /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0ED90AE: (within /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0E43CE2: PyObject_Call (in /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0ED95F2: PyEval_CallObjectWithKeywords (in /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0EDC275: PyEval_EvalFrameEx (in /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0EE1122: PyEval_EvalCodeEx (in /usr/lib64/libpython2.6.so.1.0)
==31196==  Address 0x4d29020 is 192 bytes inside a block of size 568 free'd
==31196==    at 0x4A0633D: free (vg_replace_malloc.c:323)
==31196==    by 0x37A986760F: __fopen_internal (in /lib64/libc-2.9.90.so)
==31196==    by 0x37C0EF0553: (within /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0EF30AD: (within /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0EF3203: (within /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0EF3871: (within /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0EF3E03: PyImport_ImportModuleLevel (in /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0ED90AE: (within /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0E43CE2: PyObject_Call (in /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0ED95F2: PyEval_CallObjectWithKeywords (in /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0EDC275: PyEval_EvalFrameEx (in /usr/lib64/libpython2.6.so.1.0)
==31196==    by 0x37C0EE1122: PyEval_EvalCodeEx (in /usr/lib64/libpython2.6.so.1.0)
==31196== 
==31196== Invalid read of size 4
==31196==    at 0x37C0E85423: PyObject_Free (in /usr/lib64/libpython2.6.so.1.0)
[...]

Expected results:
==31272== Memcheck, a memory error detector.
==31272== Copyright (C) 2002-2008, and GNU GPL'd, by Julian Seward et al.
==31272== Using LibVEX rev 1884, a library for dynamic binary translation.
==31272== Copyright (C) 2004-2008, and GNU GPL'd, by OpenWorks LLP.
==31272== Using valgrind-3.4.1, a dynamic binary instrumentation framework.
==31272== Copyright (C) 2000-2008, and GNU GPL'd, by Julian Seward et al.
==31272== For more details, rerun with: -v
==31272== 
==31272== 
==31272== ERROR SUMMARY: 0 errors from 0 contexts (suppressed: 6 from 2)
==31272== malloc/free: in use at exit: 0 bytes in 0 blocks.
==31272== malloc/free: 29 allocs, 29 frees, 3,920 bytes allocated.
==31272== For counts of detected errors, rerun with: -v
==31272== All heap blocks were freed -- no leaks are possible.

Additional info:
Comment 1 James Antill 2009-05-11 15:00:06 EDT
 I assume you didn't use /usr/share/doc/python-devel-2.*/valgrind-python.supp
in the python-devel package?
Comment 2 Jan Kratochvil 2009-05-11 16:19:42 EDT
Thanks, I was not aware of it, I could probably Google it. :-/

It just needs a fix - attached - for x86_64 as otherwise I get (even after enabling the ### lines of PyObject_Free+PyObject_Realloc there):

==30722== Memcheck, a memory error detector.
==30722== Copyright (C) 2002-2008, and GNU GPL'd, by Julian Seward et al.
==30722== Using LibVEX rev 1884, a library for dynamic binary translation.
==30722== Copyright (C) 2004-2008, and GNU GPL'd, by OpenWorks LLP.
==30722== Using valgrind-3.4.1, a dynamic binary instrumentation framework.
==30722== Copyright (C) 2000-2008, and GNU GPL'd, by Julian Seward et al.
==30722== For more details, rerun with: -v
==30722== 
==30722== Use of uninitialised value of size 8
==30722==    at 0x37C0E85446: PyObject_Free (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E59A95: (within /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E97740: (within /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E59B62: (within /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EF1A27: (within /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EF2F74: (within /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EF3203: (within /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EF3871: (within /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EF3E03: PyImport_ImportModuleLevel (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0ED90AE: (within /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E43CE2: PyObject_Call (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0ED95F2: PyEval_CallObjectWithKeywords (in /usr/lib64/libpython2.6.so.1.0)
==30722== 
==30722== Use of uninitialised value of size 8
==30722==    at 0x37C0E85446: PyObject_Free (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E3C2ED: PyGrammar_AddAccelerators (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E3D104: PyParser_New (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E3D172: (within /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EFC6C1: PyParser_ASTFromString (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EFCAC7: PyRun_StringFlags (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0ED87DD: (within /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EDF472: PyEval_EvalFrameEx (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EE0804: PyEval_EvalFrameEx (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EE1122: PyEval_EvalCodeEx (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EE1231: PyEval_EvalCode (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EF15E3: PyImport_ExecCodeModuleEx (in /usr/lib64/libpython2.6.so.1.0)
==30722== 
==30722== Use of uninitialised value of size 8
==30722==    at 0x37C0E85FCA: PyObject_Realloc (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E3C971: PyNode_AddChild (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E3CCDF: PyParser_AddToken (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E3D203: (within /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EFC6C1: PyParser_ASTFromString (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EFCAC7: PyRun_StringFlags (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EDE3EF: PyEval_EvalFrameEx (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EE1122: PyEval_EvalCodeEx (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EDF857: PyEval_EvalFrameEx (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EE1122: PyEval_EvalCodeEx (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EDF857: PyEval_EvalFrameEx (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EE0804: PyEval_EvalFrameEx (in /usr/lib64/libpython2.6.so.1.0)
Python 2.6 (r26:66714, Mar 17 2009, 11:44:14) 
[GCC 4.4.0 20090313 (Red Hat 4.4.0-0.26)] on linux2
Type "help", "copyright", "credits" or "license" for more information.
>>> 
==30722== 
==30722== Use of uninitialised value of size 8
==30722==    at 0x37C0E85446: PyObject_Free (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E59AAA: (within /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E6E942: (within /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E7D946: (within /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E804AF: PyDict_SetItem (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E81FB9: _PyModule_Clear (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EF46C1: PyImport_Cleanup (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EFD58C: Py_Finalize (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0F0A36A: Py_Main (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37A981E9DC: (below main) (in /lib64/libc-2.9.90.so)
==30722== 
==30722== Use of uninitialised value of size 8
==30722==    at 0x37C0E85446: PyObject_Free (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E6E972: (within /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E7D946: (within /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E804AF: PyDict_SetItem (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E8206C: _PyModule_Clear (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EF46C1: PyImport_Cleanup (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EFD58C: Py_Finalize (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0F0A36A: Py_Main (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37A981E9DC: (below main) (in /lib64/libc-2.9.90.so)
==30722== 
==30722== Use of uninitialised value of size 8
==30722==    at 0x37C0E85446: PyObject_Free (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0E7DB4A: PyDict_Fini (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0EFD604: Py_Finalize (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37C0F0A36A: Py_Main (in /usr/lib64/libpython2.6.so.1.0)
==30722==    by 0x37A981E9DC: (below main) (in /lib64/libc-2.9.90.so)
==30722== 
==30722== ERROR SUMMARY: 12 errors from 6 contexts (suppressed: 621 from 6)
==30722== malloc/free: in use at exit: 1,308,316 bytes in 521 blocks.
==30722== malloc/free: 3,068 allocs, 2,547 frees, 3,291,475 bytes allocated.
==30722== For counts of detected errors, rerun with: -v
==30722== Use --track-origins=yes to see where uninitialised values come from
==30722== searching for pointers to 521 not-freed blocks.
==30722== checked 1,456,816 bytes.
==30722== 
==30722== LEAK SUMMARY:
==30722==    definitely lost: 0 bytes in 0 blocks.
==30722==      possibly lost: 6,104 bytes in 13 blocks.
==30722==    still reachable: 1,302,212 bytes in 508 blocks.
==30722==         suppressed: 0 bytes in 0 blocks.
==30722== Rerun with --leak-check=full to see details of leaked memory.
Comment 3 Jan Kratochvil 2009-05-11 16:20:23 EDT
Created attachment 343503 [details]
Fix for x86_64.
Comment 4 Bug Zapper 2009-06-09 11:38:32 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 11 development cycle.
Changing version to '11'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 5 Bug Zapper 2010-11-04 07:15:05 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 6 Bug Zapper 2010-12-05 01:54:27 EST
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 7 Jan Kratochvil 2010-12-15 18:38:18 EST
python-2.7-8.fc14.1.x86_64
valgrind-3.5.0-19.fc14.x86_64

/usr/bin/valgrind python
==952== Memcheck, a memory error detector
==952== Copyright (C) 2002-2009, and GNU GPL'd, by Julian Seward et al.
==952== Using Valgrind-3.5.0 and LibVEX; rerun with -h for copyright info
==952== Command: python
==952== 
==952== Invalid read of size 4
==952==    at 0x4F23B28: convertitem (getargs.c:1142)
==952==    by 0x4F25DA2: vgetargs1 (getargs.c:345)
==952==    by 0x4F2634C: _PyArg_ParseTuple_SizeT (getargs.c:97)
==952==    by 0x4F4F595: posix_do_stat.clone.1 (posixmodule.c:1482)
==952==    by 0x4F1665A: PyEval_EvalFrameEx (ceval.c:4071)
==952==    by 0x4F1771C: PyEval_EvalFrameEx (ceval.c:4157)
==952==    by 0x4F1771C: PyEval_EvalFrameEx (ceval.c:4157)
==952==    by 0x4F1804C: PyEval_EvalCodeEx (ceval.c:3311)
==952==    by 0x4F18161: PyEval_EvalCode (ceval.c:670)
==952==    by 0x4F28D01: PyImport_ExecCodeModuleEx (import.c:681)
==952==    by 0x4F2904D: load_source_module (import.c:1021)
==952==    by 0x4F2A0DE: import_submodule (import.c:2596)
==952==  Address 0x61010e8 is 40 bytes inside a block of size 41 alloc'd
==952==    at 0x4C27E46: malloc (vg_replace_malloc.c:195)
==952==    by 0x4EB9153: PyObject_Malloc (obmalloc.c:935)
==952==    by 0x4EC102B: string_concat (stringobject.c:1060)
==952==    by 0x4EC1ED4: PyString_Concat (stringobject.c:3855)
==952==    by 0x4F0FF07: string_concatenate (ceval.c:4906)
==952==    by 0x4F161E5: PyEval_EvalFrameEx (ceval.c:1603)
==952==    by 0x4F1804C: PyEval_EvalCodeEx (ceval.c:3311)
==952==    by 0x4E9EC61: function_call (funcobject.c:526)
==952==    by 0x4E75FC2: PyObject_Call (abstract.c:2522)
==952==    by 0x4F14F98: PyEval_EvalFrameEx (ceval.c:4384)
==952==    by 0x4F1771C: PyEval_EvalFrameEx (ceval.c:4157)
==952==    by 0x4F1804C: PyEval_EvalCodeEx (ceval.c:3311)
==952== 
==952== Invalid read of size 4
==952==    at 0x4F23B3D: convertitem (getargs.c:1142)
==952==    by 0x4F25DA2: vgetargs1 (getargs.c:345)
==952==    by 0x4F2634C: _PyArg_ParseTuple_SizeT (getargs.c:97)
==952==    by 0x4F4F595: posix_do_stat.clone.1 (posixmodule.c:1482)
==952==    by 0x4F1665A: PyEval_EvalFrameEx (ceval.c:4071)
==952==    by 0x4F1771C: PyEval_EvalFrameEx (ceval.c:4157)
==952==    by 0x4F1771C: PyEval_EvalFrameEx (ceval.c:4157)
==952==    by 0x4F1804C: PyEval_EvalCodeEx (ceval.c:3311)
==952==    by 0x4F18161: PyEval_EvalCode (ceval.c:670)
==952==    by 0x4F28D01: PyImport_ExecCodeModuleEx (import.c:681)
==952==    by 0x4F2904D: load_source_module (import.c:1021)
==952==    by 0x4F2A0DE: import_submodule (import.c:2596)
==952==  Address 0x6101c8c is 44 bytes inside a block of size 45 alloc'd
==952==    at 0x4C27F3E: realloc (vg_replace_malloc.c:476)
==952==    by 0x4EC1F8C: _PyString_Resize (stringobject.c:3899)
==952==    by 0x4F10044: string_concatenate (ceval.c:4890)
==952==    by 0x4F161E5: PyEval_EvalFrameEx (ceval.c:1603)
==952==    by 0x4F1804C: PyEval_EvalCodeEx (ceval.c:3311)
==952==    by 0x4E9EC61: function_call (funcobject.c:526)
==952==    by 0x4E75FC2: PyObject_Call (abstract.c:2522)
==952==    by 0x4F14F98: PyEval_EvalFrameEx (ceval.c:4384)
==952==    by 0x4F1771C: PyEval_EvalFrameEx (ceval.c:4157)
==952==    by 0x4F1804C: PyEval_EvalCodeEx (ceval.c:3311)
==952==    by 0x4F18161: PyEval_EvalCode (ceval.c:670)
==952==    by 0x4F28D01: PyImport_ExecCodeModuleEx (import.c:681)
==952== 
==952== Invalid read of size 4
==952==    at 0x4F23B28: convertitem (getargs.c:1142)
==952==    by 0x4F2583D: vgetargskeywords (getargs.c:1607)
==952==    by 0x4F26578: _PyArg_ParseTupleAndKeywords_SizeT (getargs.c:1453)
==952==    by 0x4E96519: file_init (fileobject.c:2307)
==952==    by 0x4ED16B7: type_call (typeobject.c:725)
==952==    by 0x4E75FC2: PyObject_Call (abstract.c:2522)
==952==    by 0x4F1665A: PyEval_EvalFrameEx (ceval.c:4071)
==952==    by 0x4F1804C: PyEval_EvalCodeEx (ceval.c:3311)
==952==    by 0x4F16639: PyEval_EvalFrameEx (ceval.c:4167)
==952==    by 0x4F1771C: PyEval_EvalFrameEx (ceval.c:4157)
==952==    by 0x4F1804C: PyEval_EvalCodeEx (ceval.c:3311)
==952==    by 0x4F16639: PyEval_EvalFrameEx (ceval.c:4167)
==952==  Address 0x617a9b8 is 72 bytes inside a block of size 73 alloc'd
==952==    at 0x4C27F3E: realloc (vg_replace_malloc.c:476)
==952==    by 0x4EC1F8C: _PyString_Resize (stringobject.c:3899)
==952==    by 0x4F10044: string_concatenate (ceval.c:4890)
==952==    by 0x4F161E5: PyEval_EvalFrameEx (ceval.c:1603)
==952==    by 0x4F1804C: PyEval_EvalCodeEx (ceval.c:3311)
==952==    by 0x4F16639: PyEval_EvalFrameEx (ceval.c:4167)
==952==    by 0x4F1771C: PyEval_EvalFrameEx (ceval.c:4157)
==952==    by 0x4F1771C: PyEval_EvalFrameEx (ceval.c:4157)
==952==    by 0x4F1804C: PyEval_EvalCodeEx (ceval.c:3311)
==952==    by 0x4F16639: PyEval_EvalFrameEx (ceval.c:4167)
==952==    by 0x4F1771C: PyEval_EvalFrameEx (ceval.c:4157)
==952==    by 0x4F1771C: PyEval_EvalFrameEx (ceval.c:4157)
==952== 
==952== Invalid read of size 4
==952==    at 0x4F23B3D: convertitem (getargs.c:1142)
==952==    by 0x4F25DA2: vgetargs1 (getargs.c:345)
==952==    by 0x4F2634C: _PyArg_ParseTuple_SizeT (getargs.c:97)
==952==    by 0x4F4E99E: posix_listdir (posixmodule.c:2311)
==952==    by 0x4F1665A: PyEval_EvalFrameEx (ceval.c:4071)
==952==    by 0x4F1804C: PyEval_EvalCodeEx (ceval.c:3311)
==952==    by 0x4F16639: PyEval_EvalFrameEx (ceval.c:4167)
==952==    by 0x4F1771C: PyEval_EvalFrameEx (ceval.c:4157)
==952==    by 0x4F1771C: PyEval_EvalFrameEx (ceval.c:4157)
==952==    by 0x4F1804C: PyEval_EvalCodeEx (ceval.c:3311)
==952==    by 0x4F18161: PyEval_EvalCode (ceval.c:670)
==952==    by 0x4F28D01: PyImport_ExecCodeModuleEx (import.c:681)
==952==  Address 0x67f3f64 is 68 bytes inside a block of size 71 alloc'd
==952==    at 0x4C27E46: malloc (vg_replace_malloc.c:195)
==952==    by 0x4EB9153: PyObject_Malloc (obmalloc.c:935)
==952==    by 0x4EC102B: string_concat (stringobject.c:1060)
==952==    by 0x4EC1ED4: PyString_Concat (stringobject.c:3855)
==952==    by 0x4F0FF07: string_concatenate (ceval.c:4906)
==952==    by 0x4F161E5: PyEval_EvalFrameEx (ceval.c:1603)
==952==    by 0x4F1771C: PyEval_EvalFrameEx (ceval.c:4157)
==952==    by 0x4F1771C: PyEval_EvalFrameEx (ceval.c:4157)
==952==    by 0x4F1804C: PyEval_EvalCodeEx (ceval.c:3311)
==952==    by 0x4F16639: PyEval_EvalFrameEx (ceval.c:4167)
==952==    by 0x4F1804C: PyEval_EvalCodeEx (ceval.c:3311)
==952==    by 0x4F16639: PyEval_EvalFrameEx (ceval.c:4167)
==952== 
Python 2.7 (r27:82500, Sep 16 2010, 18:02:00) 
[GCC 4.5.1 20100907 (Red Hat 4.5.1-3)] on linux2
Type "help", "copyright", "credits" or "license" for more information.
>>> 
==952== 
==952== HEAP SUMMARY:
==952==     in use at exit: 897,836 bytes in 4,773 blocks
==952==   total heap usage: 38,157 allocs, 33,384 frees, 9,044,309 bytes allocated
==952== 
==952== LEAK SUMMARY:
==952==    definitely lost: 0 bytes in 0 blocks
==952==    indirectly lost: 0 bytes in 0 blocks
==952==      possibly lost: 774,596 bytes in 4,455 blocks
==952==    still reachable: 123,240 bytes in 318 blocks
==952==         suppressed: 0 bytes in 0 blocks
==952== Rerun with --leak-check=full to see details of leaked memory
==952== 
==952== For counts of detected and suppressed errors, rerun with: -v
==952== ERROR SUMMARY: 13 errors from 4 contexts (suppressed: 12 from 8)
Comment 8 Jan Kratochvil 2010-12-29 01:07:04 EST
Duplicate but filed for valgrind: Bug 658949
Comment 9 Dave Malcolm 2011-10-10 12:04:37 EDT
Note that more recent versions of Python detect if they're being run under valgrind and automatically suppress the arena allocator, as of this build:

* Wed Dec 16 2009 David Malcolm <dmalcolm@redhat.com> - 2.6.4-4
- automatically disable arena allocator when run under valgrind (upstream
issue 2422; patch 52)

On this Fedora 15 box, with python-2.7.1-7.fc15.x86_64

==14690== LEAK SUMMARY:
==14690==    definitely lost: 0 bytes in 0 blocks
==14690==    indirectly lost: 0 bytes in 0 blocks
==14690==      possibly lost: 299,030 bytes in 1,198 blocks
==14690==    still reachable: 876,699 bytes in 7,882 blocks
==14690==         suppressed: 0 bytes in 0 blocks
==14690== Reachable blocks (those to which a pointer was found) are not shown.
==14690== To see them, rerun with: --leak-check=full --show-reachable=yes
Comment 10 Jan Kratochvil 2011-10-10 12:43:17 EDT
I do not care much about memory leaks but there were other memory access errors.
Fortunately (tested only startup in F-16.x86_64) it also seems fixed, great, GDB may get debuggable even without --without-python.
Comment 11 Fedora End Of Life 2012-08-16 17:55:40 EDT
This message is a notice that Fedora 14 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 14. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained.  At this time, all open bugs with a Fedora 'version'
of '14' have been closed as WONTFIX.

(Please note: Our normal process is to give advanced warning of this 
occurring, but we forgot to do that. A thousand apologies.)

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, feel free to reopen 
this bug and simply change the 'version' to a later Fedora version.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we were unable to fix it before Fedora 14 reached end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" (top right of this page) and open it against that 
version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Note You need to log in before you can comment on or make changes to this bug.